
package net.mcreator.spacecraft_story_mod.gui.overlay;

import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.eventbus.api.EventPriority;
import net.minecraftforge.common.MinecraftForge;
import net.minecraftforge.client.event.RenderGameOverlayEvent;
import net.minecraftforge.api.distmarker.OnlyIn;
import net.minecraftforge.api.distmarker.Dist;

import net.minecraft.world.World;
import net.minecraft.entity.player.PlayerEntity;
import net.minecraft.client.Minecraft;

import net.mcreator.spacecraft_story_mod.SpacecraftStoryModModVariables;
import net.mcreator.spacecraft_story_mod.SpacecraftStoryModModElements;

@SpacecraftStoryModModElements.ModElement.Tag
public class DaysOverlay extends SpacecraftStoryModModElements.ModElement {
	public DaysOverlay(SpacecraftStoryModModElements instance) {
		super(instance, 63);
	}

	@Override
	public void initElements() {
		MinecraftForge.EVENT_BUS.register(this);
	}

	@OnlyIn(Dist.CLIENT)
	@SubscribeEvent(priority = EventPriority.NORMAL)
	public void eventHandler(RenderGameOverlayEvent event) {
		if (!event.isCancelable() && event.getType() == RenderGameOverlayEvent.ElementType.HELMET) {
			int posX = (event.getWindow().getScaledWidth()) / 2;
			int posY = (event.getWindow().getScaledHeight()) / 2;
			PlayerEntity entity = Minecraft.getInstance().player;
			World world = entity.world;
			int x = (int) entity.getPosX();
			int y = (int) entity.getPosY();
			int z = (int) entity.getPosZ();
			if ((true)) {
				Minecraft.getInstance().fontRenderer.drawString("Days survived:" + (SpacecraftStoryModModVariables.MapVariables.get(world).days) + "",
						posX + 36, posY + -116, -6737152);
			}
		}
	}
}
