
package net.mcreator.spacecraft_story_mod.item;

import net.minecraftforge.registries.ObjectHolder;

import net.minecraft.world.World;
import net.minecraft.item.UseAction;
import net.minecraft.item.ItemStack;
import net.minecraft.item.Item;
import net.minecraft.item.Food;
import net.minecraft.entity.LivingEntity;

import net.mcreator.spacecraft_story_mod.procedures.GleneFoodEatenProcedure;
import net.mcreator.spacecraft_story_mod.itemgroup.CreativeTabItemGroup;
import net.mcreator.spacecraft_story_mod.SpacecraftStoryModModElements;

@SpacecraftStoryModModElements.ModElement.Tag
public class GleneItem extends SpacecraftStoryModModElements.ModElement {
	@ObjectHolder("spacecraft_story_mod:glene")
	public static final Item block = null;
	public GleneItem(SpacecraftStoryModModElements instance) {
		super(instance, 78);
	}

	@Override
	public void initElements() {
		elements.items.add(() -> new FoodItemCustom());
	}
	public static class FoodItemCustom extends Item {
		public FoodItemCustom() {
			super(new Item.Properties().group(CreativeTabItemGroup.tab).maxStackSize(64)
					.food((new Food.Builder()).hunger(4).saturation(1.1f).setAlwaysEdible().build()));
			setRegistryName("glene");
		}

		@Override
		public UseAction getUseAction(ItemStack par1ItemStack) {
			return UseAction.EAT;
		}

		@Override
		public ItemStack onItemUseFinish(ItemStack itemStack, World world, LivingEntity entity) {
			ItemStack retval = super.onItemUseFinish(itemStack, world, entity);
			int x = (int) entity.getPosX();
			int y = (int) entity.getPosY();
			int z = (int) entity.getPosZ();
			{
				java.util.HashMap<String, Object> $_dependencies = new java.util.HashMap<>();
				$_dependencies.put("entity", entity);
				$_dependencies.put("x", x);
				$_dependencies.put("y", y);
				$_dependencies.put("z", z);
				$_dependencies.put("world", world);
				GleneFoodEatenProcedure.executeProcedure($_dependencies);
			}
			return retval;
		}
	}
}
