
package net.mcreator.spacecraft_story_mod.item;

import net.minecraftforge.registries.ObjectHolder;

import net.minecraft.world.World;
import net.minecraft.util.Hand;
import net.minecraft.util.ActionResult;
import net.minecraft.item.ItemStack;
import net.minecraft.item.Item;
import net.minecraft.entity.player.PlayerEntity;
import net.minecraft.entity.Entity;
import net.minecraft.block.BlockState;

import net.mcreator.spacecraft_story_mod.procedures.OxygenbottleItemIsCraftedsmeltedProcedure;
import net.mcreator.spacecraft_story_mod.procedures.OxygenRefillRightClickedInAirProcedure;
import net.mcreator.spacecraft_story_mod.procedures.OxygenRefillItemInHandTickProcedure;
import net.mcreator.spacecraft_story_mod.itemgroup.CreativeTabItemGroup;
import net.mcreator.spacecraft_story_mod.SpacecraftStoryModModElements;

@SpacecraftStoryModModElements.ModElement.Tag
public class OxygenbottleItem extends SpacecraftStoryModModElements.ModElement {
	@ObjectHolder("spacecraft_story_mod:oxygenbottle")
	public static final Item block = null;
	public OxygenbottleItem(SpacecraftStoryModModElements instance) {
		super(instance, 4);
	}

	@Override
	public void initElements() {
		elements.items.add(() -> new ItemCustom());
	}
	public static class ItemCustom extends Item {
		public ItemCustom() {
			super(new Item.Properties().group(CreativeTabItemGroup.tab).maxStackSize(1));
			setRegistryName("oxygenbottle");
		}

		@Override
		public int getItemEnchantability() {
			return 0;
		}

		@Override
		public int getUseDuration(ItemStack itemstack) {
			return 0;
		}

		@Override
		public float getDestroySpeed(ItemStack par1ItemStack, BlockState par2Block) {
			return 1F;
		}

		@Override
		public ActionResult<ItemStack> onItemRightClick(World world, PlayerEntity entity, Hand hand) {
			ActionResult<ItemStack> ar = super.onItemRightClick(world, entity, hand);
			ItemStack itemstack = ar.getResult();
			int x = (int) entity.getPosX();
			int y = (int) entity.getPosY();
			int z = (int) entity.getPosZ();
			{
				java.util.HashMap<String, Object> $_dependencies = new java.util.HashMap<>();
				$_dependencies.put("itemstack", itemstack);
				$_dependencies.put("world", world);
				OxygenRefillRightClickedInAirProcedure.executeProcedure($_dependencies);
			}
			return ar;
		}

		@Override
		public void onCreated(ItemStack itemstack, World world, PlayerEntity entity) {
			super.onCreated(itemstack, world, entity);
			int x = (int) entity.getPosX();
			int y = (int) entity.getPosY();
			int z = (int) entity.getPosZ();
			{
				java.util.HashMap<String, Object> $_dependencies = new java.util.HashMap<>();
				$_dependencies.put("itemstack", itemstack);
				OxygenbottleItemIsCraftedsmeltedProcedure.executeProcedure($_dependencies);
			}
		}

		@Override
		public void inventoryTick(ItemStack itemstack, World world, Entity entity, int slot, boolean selected) {
			super.inventoryTick(itemstack, world, entity, slot, selected);
			int x = (int) entity.getPosX();
			int y = (int) entity.getPosY();
			int z = (int) entity.getPosZ();
			if (selected) {
				java.util.HashMap<String, Object> $_dependencies = new java.util.HashMap<>();
				$_dependencies.put("entity", entity);
				$_dependencies.put("itemstack", itemstack);
				$_dependencies.put("world", world);
				OxygenRefillItemInHandTickProcedure.executeProcedure($_dependencies);
			}
		}
	}
}
