package net.mcreator.spacecraft_story_mod.procedures;

import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.event.TickEvent;
import net.minecraftforge.common.MinecraftForge;

import net.minecraft.world.World;
import net.minecraft.util.ResourceLocation;
import net.minecraft.server.MinecraftServer;
import net.minecraft.entity.player.ServerPlayerEntity;
import net.minecraft.entity.Entity;
import net.minecraft.advancements.AdvancementProgress;
import net.minecraft.advancements.Advancement;

import net.mcreator.spacecraft_story_mod.SpacecraftStoryModModVariables;
import net.mcreator.spacecraft_story_mod.SpacecraftStoryModModElements;

import java.util.Iterator;

@SpacecraftStoryModModElements.ModElement.Tag
public class CheckdaysProcedure extends SpacecraftStoryModModElements.ModElement {
	public CheckdaysProcedure(SpacecraftStoryModModElements instance) {
		super(instance, 60);
		MinecraftForge.EVENT_BUS.register(this);
	}

	public static void executeProcedure(java.util.HashMap<String, Object> dependencies) {
		if (dependencies.get("entity") == null) {
			System.err.println("Failed to load dependency entity for procedure Checkdays!");
			return;
		}
		if (dependencies.get("world") == null) {
			System.err.println("Failed to load dependency world for procedure Checkdays!");
			return;
		}
		Entity entity = (Entity) dependencies.get("entity");
		World world = (World) dependencies.get("world");
		SpacecraftStoryModModVariables.MapVariables
				.get(world).ticksfromstart = (double) ((SpacecraftStoryModModVariables.MapVariables.get(world).ticksfromstart) + 1);
		SpacecraftStoryModModVariables.MapVariables.get(world).syncData(world);
		SpacecraftStoryModModVariables.MapVariables.get(world).days = (double) Math
				.round(((SpacecraftStoryModModVariables.MapVariables.get(world).ticksfromstart) / 24000));
		SpacecraftStoryModModVariables.MapVariables.get(world).syncData(world);
		if (((SpacecraftStoryModModVariables.MapVariables.get(world).days) >= 15)) {
			if (entity instanceof ServerPlayerEntity) {
				Advancement _adv = ((MinecraftServer) ((ServerPlayerEntity) entity).server).getAdvancementManager()
						.getAdvancement(new ResourceLocation("spacecraft_story_mod:greatsurvivor"));
				AdvancementProgress _ap = ((ServerPlayerEntity) entity).getAdvancements().getProgress(_adv);
				if (!_ap.isDone()) {
					Iterator _iterator = _ap.getRemaningCriteria().iterator();
					while (_iterator.hasNext()) {
						String _criterion = (String) _iterator.next();
						((ServerPlayerEntity) entity).getAdvancements().grantCriterion(_adv, _criterion);
					}
				}
			}
		}
	}

	@SubscribeEvent
	public void onPlayerTick(TickEvent.PlayerTickEvent event) {
		if (event.phase == TickEvent.Phase.END) {
			Entity entity = event.player;
			World world = entity.world;
			int i = (int) entity.getPosX();
			int j = (int) entity.getPosY();
			int k = (int) entity.getPosZ();
			java.util.HashMap<String, Object> dependencies = new java.util.HashMap<>();
			dependencies.put("x", i);
			dependencies.put("y", j);
			dependencies.put("z", k);
			dependencies.put("world", world);
			dependencies.put("entity", entity);
			dependencies.put("event", event);
			this.executeProcedure(dependencies);
		}
	}
}
