package net.mcreator.spacecraft_story_mod.procedures;

import net.minecraftforge.items.ItemHandlerHelper;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.event.entity.player.PlayerEvent;
import net.minecraftforge.common.MinecraftForge;

import net.minecraft.world.server.ServerWorld;
import net.minecraft.world.gen.feature.template.Template;
import net.minecraft.world.gen.feature.template.PlacementSettings;
import net.minecraft.world.World;
import net.minecraft.util.math.ChunkPos;
import net.minecraft.util.math.BlockPos;
import net.minecraft.util.Rotation;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.Mirror;
import net.minecraft.item.ItemStack;
import net.minecraft.entity.player.ServerPlayerEntity;
import net.minecraft.entity.player.PlayerEntity;
import net.minecraft.entity.Entity;

import net.mcreator.spacecraft_story_mod.item.OxygenbottleItem;
import net.mcreator.spacecraft_story_mod.SpacecraftStoryModModVariables;
import net.mcreator.spacecraft_story_mod.SpacecraftStoryModModElements;

import java.util.Collections;

@SpacecraftStoryModModElements.ModElement.Tag
public class OnPlayerSpawnProcedure extends SpacecraftStoryModModElements.ModElement {
	public OnPlayerSpawnProcedure(SpacecraftStoryModModElements instance) {
		super(instance, 54);
		MinecraftForge.EVENT_BUS.register(this);
	}

	public static void executeProcedure(java.util.HashMap<String, Object> dependencies) {
		if (dependencies.get("entity") == null) {
			System.err.println("Failed to load dependency entity for procedure OnPlayerSpawn!");
			return;
		}
		if (dependencies.get("x") == null) {
			System.err.println("Failed to load dependency x for procedure OnPlayerSpawn!");
			return;
		}
		if (dependencies.get("y") == null) {
			System.err.println("Failed to load dependency y for procedure OnPlayerSpawn!");
			return;
		}
		if (dependencies.get("z") == null) {
			System.err.println("Failed to load dependency z for procedure OnPlayerSpawn!");
			return;
		}
		if (dependencies.get("world") == null) {
			System.err.println("Failed to load dependency world for procedure OnPlayerSpawn!");
			return;
		}
		Entity entity = (Entity) dependencies.get("entity");
		int x = (int) dependencies.get("x");
		int y = (int) dependencies.get("y");
		int z = (int) dependencies.get("z");
		World world = (World) dependencies.get("world");
		ItemStack o_botle = ItemStack.EMPTY;
		if (((SpacecraftStoryModModVariables.MapVariables.get(world).HAS_SHIPWE) == (false))) {
			if (!world.isRemote) {
				Template template = ((ServerWorld) world.getWorld()).getSaveHandler().getStructureTemplateManager()
						.getTemplateDefaulted(new ResourceLocation("spacecraft_story_mod", "shipwnew"));
				if (template != null) {
					template.addBlocksToWorldChunk(world, new BlockPos((int) (x - 2), (int) (y + 1), (int) (z - 2)), new PlacementSettings()
							.setRotation(Rotation.NONE).setMirror(Mirror.NONE).setChunk((ChunkPos) null).setIgnoreEntities(false));
				}
			}
			{
				Entity _ent = entity;
				_ent.setPositionAndUpdate(x, (y + 2), z);
				if (_ent instanceof ServerPlayerEntity) {
					((ServerPlayerEntity) _ent).connection.setPlayerLocation(x, (y + 2), z, _ent.rotationYaw, _ent.rotationPitch,
							Collections.emptySet());
				}
			}
			o_botle = new ItemStack(OxygenbottleItem.block, (int) (1));
			(o_botle).getOrCreateTag().putBoolean("isCrafted", (false));
			(o_botle).getOrCreateTag().putDouble("Contains", 0);
			if (entity instanceof PlayerEntity) {
				ItemStack _setstack = (o_botle);
				_setstack.setCount((int) 1);
				ItemHandlerHelper.giveItemToPlayer(((PlayerEntity) entity), _setstack);
			}
			SpacecraftStoryModModVariables.MapVariables.get(world).HAS_SHIPWE = (boolean) (true);
			SpacecraftStoryModModVariables.MapVariables.get(world).syncData(world);
			if (entity instanceof PlayerEntity)
				((PlayerEntity) entity).setSpawnPoint(new BlockPos((int) x, (int) (y + 2), (int) z), true, false, entity.dimension);
		}
	}

	@SubscribeEvent
	public void onPlayerLoggedIn(PlayerEvent.PlayerLoggedInEvent event) {
		Entity entity = event.getPlayer();
		java.util.HashMap<String, Object> dependencies = new java.util.HashMap<>();
		dependencies.put("x", (int) entity.getPosX());
		dependencies.put("y", (int) entity.getPosY());
		dependencies.put("z", (int) entity.getPosZ());
		dependencies.put("world", entity.world);
		dependencies.put("entity", entity);
		dependencies.put("event", event);
		this.executeProcedure(dependencies);
	}
}
