package net.mcreator.spacecraft_story_mod.procedures;

import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.event.TickEvent;
import net.minecraftforge.common.MinecraftForge;

import net.minecraft.world.World;
import net.minecraft.util.math.BlockPos;
import net.minecraft.util.ResourceLocation;
import net.minecraft.server.MinecraftServer;
import net.minecraft.entity.player.ServerPlayerEntity;
import net.minecraft.entity.Entity;
import net.minecraft.block.Blocks;
import net.minecraft.advancements.AdvancementProgress;
import net.minecraft.advancements.Advancement;

import net.mcreator.spacecraft_story_mod.SpacecraftStoryModModVariables;
import net.mcreator.spacecraft_story_mod.SpacecraftStoryModModElements;

import java.util.Iterator;

@SpacecraftStoryModModElements.ModElement.Tag
public class YourTempChangingProcedureProcedure extends SpacecraftStoryModModElements.ModElement {
	public YourTempChangingProcedureProcedure(SpacecraftStoryModModElements instance) {
		super(instance, 21);
		MinecraftForge.EVENT_BUS.register(this);
	}

	public static void executeProcedure(java.util.HashMap<String, Object> dependencies) {
		if (dependencies.get("entity") == null) {
			System.err.println("Failed to load dependency entity for procedure YourTempChangingProcedure!");
			return;
		}
		if (dependencies.get("x") == null) {
			System.err.println("Failed to load dependency x for procedure YourTempChangingProcedure!");
			return;
		}
		if (dependencies.get("y") == null) {
			System.err.println("Failed to load dependency y for procedure YourTempChangingProcedure!");
			return;
		}
		if (dependencies.get("z") == null) {
			System.err.println("Failed to load dependency z for procedure YourTempChangingProcedure!");
			return;
		}
		if (dependencies.get("world") == null) {
			System.err.println("Failed to load dependency world for procedure YourTempChangingProcedure!");
			return;
		}
		Entity entity = (Entity) dependencies.get("entity");
		int x = (int) dependencies.get("x");
		int y = (int) dependencies.get("y");
		int z = (int) dependencies.get("z");
		World world = (World) dependencies.get("world");
		if ((Math.random() < 0.001)) {
			SpacecraftStoryModModVariables.MapVariables
					.get(world).YourTemp = (double) ((SpacecraftStoryModModVariables.MapVariables.get(world).YourTemp) + 1);
			SpacecraftStoryModModVariables.MapVariables.get(world).syncData(world);
		}
		if ((Math.random() < 0.001)) {
			SpacecraftStoryModModVariables.MapVariables
					.get(world).YourTemp = (double) ((SpacecraftStoryModModVariables.MapVariables.get(world).YourTemp) - 1);
			SpacecraftStoryModModVariables.MapVariables.get(world).syncData(world);
		}
		if (((((world.getBlockState(new BlockPos((int) x, (int) y, (int) z))).getBlock() == Blocks.WATER.getDefaultState().getBlock())
				|| ((world.getBlockState(new BlockPos((int) x, (int) y, (int) z))).getBlock() == Blocks.WATER.getDefaultState().getBlock()))
				|| ((world.getBlockState(new BlockPos((int) x, (int) y, (int) z))).getBlock() == Blocks.BUBBLE_COLUMN.getDefaultState()
						.getBlock()))) {
			if ((Math.random() < 0.03)) {
				SpacecraftStoryModModVariables.MapVariables
						.get(world).YourTemp = (double) ((SpacecraftStoryModModVariables.MapVariables.get(world).YourTemp) - 1);
				SpacecraftStoryModModVariables.MapVariables.get(world).syncData(world);
			}
		}
		if (((SpacecraftStoryModModVariables.MapVariables.get(world).YourTemp) < 8)) {
			SpacecraftStoryModModVariables.MapVariables.get(world).YourTemp = (double) 8;
			SpacecraftStoryModModVariables.MapVariables.get(world).syncData(world);
		}
		if (((SpacecraftStoryModModVariables.MapVariables.get(world).YourTemp) > 50)) {
			if (entity instanceof ServerPlayerEntity) {
				Advancement _adv = ((MinecraftServer) ((ServerPlayerEntity) entity).server).getAdvancementManager()
						.getAdvancement(new ResourceLocation("spacecraft_story_mod:overheated"));
				AdvancementProgress _ap = ((ServerPlayerEntity) entity).getAdvancements().getProgress(_adv);
				if (!_ap.isDone()) {
					Iterator _iterator = _ap.getRemaningCriteria().iterator();
					while (_iterator.hasNext()) {
						String _criterion = (String) _iterator.next();
						((ServerPlayerEntity) entity).getAdvancements().grantCriterion(_adv, _criterion);
					}
				}
			}
			SpacecraftStoryModModVariables.MapVariables.get(world).YourTemp = (double) 50;
			SpacecraftStoryModModVariables.MapVariables.get(world).syncData(world);
		}
		if ((((((world.getBlockState(new BlockPos((int) x, (int) y, (int) z))).getBlock() == Blocks.LAVA.getDefaultState().getBlock())
				|| ((world.getBlockState(new BlockPos((int) x, (int) y, (int) z))).getBlock() == Blocks.LAVA.getDefaultState().getBlock()))
				|| ((world.getBlockState(new BlockPos((int) x, (int) y, (int) z))).getBlock() == Blocks.FIRE.getDefaultState().getBlock()))
				|| (((world.getBlockState(new BlockPos((int) x, (int) y, (int) z))).getBlock() == Blocks.TORCH.getDefaultState().getBlock())
						|| ((world.getBlockState(new BlockPos((int) x, (int) y, (int) z))).getBlock() == Blocks.WALL_TORCH.getDefaultState()
								.getBlock())))) {
			if ((Math.random() < 0.03)) {
				SpacecraftStoryModModVariables.MapVariables
						.get(world).YourTemp = (double) ((SpacecraftStoryModModVariables.MapVariables.get(world).YourTemp) + 1);
				SpacecraftStoryModModVariables.MapVariables.get(world).syncData(world);
			}
		}
	}

	@SubscribeEvent
	public void onPlayerTick(TickEvent.PlayerTickEvent event) {
		if (event.phase == TickEvent.Phase.END) {
			Entity entity = event.player;
			World world = entity.world;
			int i = (int) entity.getPosX();
			int j = (int) entity.getPosY();
			int k = (int) entity.getPosZ();
			java.util.HashMap<String, Object> dependencies = new java.util.HashMap<>();
			dependencies.put("x", i);
			dependencies.put("y", j);
			dependencies.put("z", k);
			dependencies.put("world", world);
			dependencies.put("entity", entity);
			dependencies.put("event", event);
			this.executeProcedure(dependencies);
		}
	}
}
