
package net.mcreator.spacecraft_story_mod.world.dimension;

import net.minecraftforge.registries.ObjectHolder;
import net.minecraftforge.registries.ForgeRegistries;
import net.minecraftforge.fml.javafmlmod.FMLJavaModLoadingContext;
import net.minecraftforge.fml.event.lifecycle.FMLCommonSetupEvent;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.event.world.RegisterDimensionsEvent;
import net.minecraftforge.event.RegistryEvent;
import net.minecraftforge.common.ModDimension;
import net.minecraftforge.common.MinecraftForge;
import net.minecraftforge.common.DimensionManager;
import net.minecraftforge.api.distmarker.OnlyIn;
import net.minecraftforge.api.distmarker.Dist;

import net.minecraft.world.server.ServerWorld;
import net.minecraft.world.gen.layer.traits.IC0Transformer;
import net.minecraft.world.gen.layer.ZoomLayer;
import net.minecraft.world.gen.layer.Layer;
import net.minecraft.world.gen.layer.IslandLayer;
import net.minecraft.world.gen.feature.ProbabilityConfig;
import net.minecraft.world.gen.carver.CaveWorldCarver;
import net.minecraft.world.gen.area.LazyArea;
import net.minecraft.world.gen.area.IAreaFactory;
import net.minecraft.world.gen.OverworldGenSettings;
import net.minecraft.world.gen.OverworldChunkGenerator;
import net.minecraft.world.gen.LazyAreaLayerContext;
import net.minecraft.world.gen.INoiseRandom;
import net.minecraft.world.gen.IExtendedNoiseRandom;
import net.minecraft.world.gen.GenerationStage;
import net.minecraft.world.gen.ChunkGenerator;
import net.minecraft.world.dimension.DimensionType;
import net.minecraft.world.dimension.Dimension;
import net.minecraft.world.biome.provider.BiomeProvider;
import net.minecraft.world.biome.Biome;
import net.minecraft.world.World;
import net.minecraft.world.IWorld;
import net.minecraft.util.registry.Registry;
import net.minecraft.util.math.Vec3d;
import net.minecraft.util.math.MathHelper;
import net.minecraft.util.math.ChunkPos;
import net.minecraft.util.math.BlockPos;
import net.minecraft.util.ResourceLocation;
import net.minecraft.entity.player.PlayerEntity;
import net.minecraft.block.Blocks;
import net.minecraft.block.BlockState;

import net.mcreator.spacecraft_story_mod.SpacecraftStoryModModElements;

import javax.annotation.Nullable;

import java.util.function.LongFunction;
import java.util.function.BiFunction;
import java.util.HashSet;
import java.util.Arrays;

import com.google.common.collect.ImmutableSet;

@SpacecraftStoryModModElements.ModElement.Tag
public class HomeFinallyHomeDimension extends SpacecraftStoryModModElements.ModElement {
	@ObjectHolder("spacecraft_story_mod:home_finally_home")
	public static final ModDimension dimension = null;
	public static DimensionType type = null;
	private static Biome[] dimensionBiomes;
	public HomeFinallyHomeDimension(SpacecraftStoryModModElements instance) {
		super(instance, 86);
		MinecraftForge.EVENT_BUS.register(this);
		FMLJavaModLoadingContext.get().getModEventBus().register(this);
	}

	@SubscribeEvent
	public void registerDimension(RegistryEvent.Register<ModDimension> event) {
		event.getRegistry().register(new CustomModDimension().setRegistryName("home_finally_home"));
	}

	@SubscribeEvent
	public void onRegisterDimensionsEvent(RegisterDimensionsEvent event) {
		if (DimensionType.byName(new ResourceLocation("spacecraft_story_mod:home_finally_home")) == null) {
			DimensionManager.registerDimension(new ResourceLocation("spacecraft_story_mod:home_finally_home"), dimension, null, true);
		}
		type = DimensionType.byName(new ResourceLocation("spacecraft_story_mod:home_finally_home"));
	}

	@Override
	public void init(FMLCommonSetupEvent event) {
		dimensionBiomes = new Biome[]{ForgeRegistries.BIOMES.getValue(new ResourceLocation("ocean")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("plains")), ForgeRegistries.BIOMES.getValue(new ResourceLocation("desert")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("mountains")), ForgeRegistries.BIOMES.getValue(new ResourceLocation("forest")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("taiga")), ForgeRegistries.BIOMES.getValue(new ResourceLocation("swamp")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("river")), ForgeRegistries.BIOMES.getValue(new ResourceLocation("nether")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("the_end")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("frozen_ocean")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("frozen_river")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("snowy_tundra")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("snowy_mountains")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("mushroom_fields")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("mushroom_field_shore")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("beach")), ForgeRegistries.BIOMES.getValue(new ResourceLocation("desert_hills")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("wooded_hills")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("taiga_hills")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("mountain_edge")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("jungle")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("jungle_hills")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("jungle_edge")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("deep_ocean")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("stone_shore")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("snowy_beach")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("birch_forest")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("birch_forest_hills")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("dark_forest")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("snowy_taiga")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("snowy_taiga_hills")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("giant_tree_taiga")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("giant_tree_taiga_hills")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("wooded_mountains")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("savanna")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("savanna_plateau")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("badlands")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("wooded_badlands_plateau")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("badlands_plateau")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("warm_ocean")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("lukewarm_ocean")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("cold_ocean")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("deep_warm_ocean")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("deep_lukewarm_ocean")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("deep_cold_ocean")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("deep_frozen_ocean")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("sunflower_plains")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("desert_lakes")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("gravelly_mountains")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("flower_forest")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("taiga_mountains")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("swamp_hills")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("ice_spikes")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("modified_jungle")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("modified_jungle_edge")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("tall_birch_forest")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("tall_birch_hills")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("dark_forest_hills")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("snowy_taiga_mountains")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("giant_spruce_taiga")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("giant_spruce_taiga_hills")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("modified_gravelly_mountains")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("shattered_savanna")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("shattered_savanna_plateau")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("eroded_badlands")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("modified_wooded_badlands_plateau")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("modified_badlands_plateau")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("bamboo_jungle")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("bamboo_jungle_hills")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("small_end_islands")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("end_midlands")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("end_highlands")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("end_barrens")),
				ForgeRegistries.BIOMES.getValue(new ResourceLocation("the_void")),};
	}
	public static class CustomModDimension extends ModDimension {
		@Override
		public BiFunction<World, DimensionType, ? extends Dimension> getFactory() {
			return CustomDimension::new;
		}
	}

	public static class CustomDimension extends Dimension {
		private BiomeProviderCustom biomeProviderCustom = null;
		public CustomDimension(World world, DimensionType type) {
			super(world, type, 0);
			this.nether = false;
		}

		@Override
		@OnlyIn(Dist.CLIENT)
		public Vec3d getFogColor(float cangle, float ticks) {
			return new Vec3d(0.752941176471, 0.847058823529, 1);
		}

		@Override
		public ChunkGenerator<?> createChunkGenerator() {
			if (this.biomeProviderCustom == null) {
				this.biomeProviderCustom = new BiomeProviderCustom(this.world);
			}
			return new ChunkProviderModded(this.world, this.biomeProviderCustom);
		}

		@Override
		public boolean isSurfaceWorld() {
			return false;
		}

		@Override
		public boolean canRespawnHere() {
			return true;
		}

		@OnlyIn(Dist.CLIENT)
		@Override
		public boolean doesXZShowFog(int x, int z) {
			return false;
		}

		@Override
		public SleepResult canSleepAt(PlayerEntity player, BlockPos pos) {
			return SleepResult.ALLOW;
		}

		@Nullable
		public BlockPos findSpawn(ChunkPos chunkPos, boolean checkValid) {
			return null;
		}

		@Nullable
		public BlockPos findSpawn(int x, int z, boolean checkValid) {
			return null;
		}

		@Override
		public boolean doesWaterVaporize() {
			return false;
		}

		@Override /**
					 * Calculates the angle of sun and moon in the sky relative to a specified time
					 * (usually worldTime)
					 */
		public float calculateCelestialAngle(long worldTime, float partialTicks) {
			double d0 = MathHelper.frac((double) worldTime / 24000.0D - 0.25D);
			double d1 = 0.5D - Math.cos(d0 * Math.PI) / 2.0D;
			return (float) (d0 * 2.0D + d1) / 3.0F;
		}
	}

	public static class ChunkProviderModded extends OverworldChunkGenerator {
		private static final int SEALEVEL = 63;
		public ChunkProviderModded(IWorld world, BiomeProvider provider) {
			super(world, provider, new OverworldGenSettings() {
				public BlockState getDefaultBlock() {
					return Blocks.STONE.getDefaultState();
				}

				public BlockState getDefaultFluid() {
					return Blocks.WATER.getDefaultState();
				}
			});
			this.randomSeed.skip(5349);
		}

		@Override
		public int getSeaLevel() {
			return SEALEVEL;
		}

		@Override
		public void spawnMobs(ServerWorld worldIn, boolean spawnHostileMobs, boolean spawnPeacefulMobs) {
		}
	}

	public static class BiomeLayerCustom implements IC0Transformer {
		@Override
		public int apply(INoiseRandom context, int value) {
			return Registry.BIOME.getId(dimensionBiomes[context.random(dimensionBiomes.length)]);
		}
	}

	public static class BiomeProviderCustom extends BiomeProvider {
		private Layer genBiomes;
		public BiomeProviderCustom(World world) {
			super(new HashSet<Biome>(Arrays.asList(dimensionBiomes)));
			this.genBiomes = getBiomeLayer(world.getSeed());
			for (Biome biome : this.biomes) {
				biome.addCarver(GenerationStage.Carving.AIR, Biome.createCarver(new CaveWorldCarver(ProbabilityConfig::deserialize, 256) {
					{
						carvableBlocks = ImmutableSet.of(Blocks.STONE.getDefaultState().getBlock(),
								biome.getSurfaceBuilder().getConfig().getTop().getBlock(),
								biome.getSurfaceBuilder().getConfig().getUnder().getBlock());
					}
				}, new ProbabilityConfig(0.14285715f)));
			}
		}

		public Biome getNoiseBiome(int x, int y, int z) {
			return this.genBiomes.func_215738_a(x, z);
		}

		private Layer getBiomeLayer(long seed) {
			LongFunction<IExtendedNoiseRandom<LazyArea>> contextFactory = l -> new LazyAreaLayerContext(25, seed, l);
			IAreaFactory<LazyArea> parentLayer = IslandLayer.INSTANCE.apply(contextFactory.apply(1));
			IAreaFactory<LazyArea> biomeLayer = (new BiomeLayerCustom()).apply(contextFactory.apply(200), parentLayer);
			biomeLayer = ZoomLayer.NORMAL.apply(contextFactory.apply(1000), biomeLayer);
			biomeLayer = ZoomLayer.NORMAL.apply(contextFactory.apply(1001), biomeLayer);
			biomeLayer = ZoomLayer.NORMAL.apply(contextFactory.apply(1002), biomeLayer);
			biomeLayer = ZoomLayer.NORMAL.apply(contextFactory.apply(1003), biomeLayer);
			biomeLayer = ZoomLayer.NORMAL.apply(contextFactory.apply(1004), biomeLayer);
			biomeLayer = ZoomLayer.NORMAL.apply(contextFactory.apply(1005), biomeLayer);
			return new Layer(biomeLayer);
		}
	}
}
